#include <stdio.h>

#include <stdlib.h>
#include <string.h>

#define MAX_DLUG 1100
#define BASE 10
#define id if(0)

typedef struct {
	int dl;
	int t[MAX_DLUG];
} bignum;

bignum *init()
{
	bignum *a = (bignum *) malloc (sizeof(bignum));
	a->dl = 0;
	memset(a->t, 0, sizeof(int)*MAX_DLUG);
	return a;
}

void fromstring(bignum *a, char *s)
{
	int i;
	memset(a->t, 0, sizeof(int) * MAX_DLUG);
	a->dl = strlen(s);
	for (i=0; i<a->dl; i++)
	{
		a->t[a->dl-i-1] = s[i] - '0';
	}
}

void wypisz(bignum *a)
{
	int i;
	for (i=a->dl-1; i>=0; i--)
	{	
		printf("%d", a->t[i]);
	}
	if (!a->dl) printf("0");
	printf("\n");
}

void dodaj (bignum *a, bignum *b, bignum *c)
{
	int i;
	
	c->dl = (a->dl > b->dl ? a->dl : b->dl);
	memset(c->t, 0, sizeof(int) * MAX_DLUG);

	for (i=0; i<c->dl; i++)
	{
		c->t[i] += (a->t[i] + b->t[i]);
		while (c->t[i] >= BASE)  
		{ 
			c->t[i+1]++; 
			c->t[i] -= BASE;
		}
	}
	if (c->t[c->dl]) c->dl++;
}

void odejmij (bignum *a, bignum *b, bignum *c)
{
	int i;
	
	memset(c->t, 0, sizeof(int) * MAX_DLUG);
/*
	if (comp(a,b) == -1)
	{
		printf("proba odjecia wiekszej od mniejszej\n");
		return;
	}
*/

	c->dl = a->dl;

	for (i=0; i<c->dl; i++)
	{
		c->t[i] += (a->t[i] - b->t[i]);
		while (c->t[i] < 0)  
		{ 
			c->t[i+1]--; 
			c->t[i] += BASE;
		}
	}
	while (c->dl >0 && !(c->t[c->dl-1])) { c->dl--; }
}

void mnoz (bignum *a, bignum *b, bignum *c)
{
	int i,j;

	memset(c->t, 0, sizeof(int) *MAX_DLUG);
	c->dl = a->dl + b->dl;

	for (i=0; i<a->dl; i++)
	{
		for (j=0; j<b->dl; j++)
		{
			c->t[i+j] += (a->t[i] * b->t[j]);
			c->t[i+j+1] += (c->t[i+j] / BASE);
			c->t[i+j] %= BASE;
		}
	}
	while (c->dl >0 && !(c->t[c->dl-1])) { c->dl--; }
}


int i,j,k;
int T,I;
char str[2000];
int lena,lenb,lenc,lene;
int dlug,dlug2;
char la[1100], lb[1100];
bignum *a,*b,*c,*d,*e;
int ilespacji;

int max (int a, int b)
{
	return (a > b ? a : b);
}

int min (int a, int b)
{
	return (a < b ? a : b);
}


void dod()
{
	int i,j;

	for (i=0; str[i]!='+'; i++)
	{
		la[i] = str[i];
	}
	la[i]=0;

	for (j=i+1; j<strlen(str); j++)
	{
		lb[j-i-1] = str[j];
	}
	lb[j-i-1]=0;

	lena = strlen(la);
	lenb = strlen(lb);
	fromstring(a, la);
	fromstring(b, lb);
	dodaj(a, b, c);

id printf("a: ");	id wypisz(a); id printf("\n");
id printf("b: ");	id wypisz(b); 

	if (c->dl) lenc = c->dl; else lenc = 1; 
	dlug = max(max(lena,lenb+1),lenc);

	for (i=0; i<dlug-lena; i++) printf (" "); 
	printf ("%s\n",la); 
	for (i=0; i<dlug-lenb-1; i++) printf (" "); 
	printf ("+%s\n",lb); 

	ilespacji = min (dlug-lenb-1,dlug-lenc);
	for (i=0; i<ilespacji; i++) printf (" "); 
	for (i=0; i<dlug-ilespacji; i++) printf ("-"); 
	printf ("\n");

	for (i=0; i<dlug-lenc; i++) printf (" "); 
	wypisz (c);

}

void ode()
{
	int i,j;

	for (i=0; str[i]!='-'; i++)
	{
		la[i] = str[i];
	}
	la[i]=0;

	for (j=i+1; j<strlen(str); j++)
	{
		lb[j-i-1] = str[j];
	}
	lb[j-i-1]=0;

	lena = strlen(la);
	lenb = strlen(lb);
	fromstring(a, la);
	fromstring(b, lb);
	odejmij(a, b, c);

	if (c->dl) lenc = c->dl; else lenc = 1;
	dlug = max(max(lena,lenb+1),lenc);

	for (i=0; i<dlug-lena; i++) printf (" "); 
	printf ("%s\n",la); 
	for (i=0; i<dlug-lenb-1; i++) printf (" "); 
	printf ("-%s\n",lb); 

	ilespacji = min (dlug-lenb-1,dlug-lenc);
	for (i=0; i<ilespacji; i++) printf (" "); 
	for (i=0; i<dlug-ilespacji; i++) printf ("-"); 
	printf ("\n");

	for (i=0; i<dlug-lenc; i++) printf (" "); 
 	wypisz (c);
}

void mno()
{
	int i,j;
	char dd[1100];
	int ilespacji;

	for (i=0; str[i]!='*'; i++)
	{
		la[i] = str[i];
	}
	la[i]=0;

	for (j=i+1; j<strlen(str); j++)
	{
		lb[j-i-1] = str[j];
	}
	lb[j-i-1]=0;

	lena = strlen(la);
	lenb = strlen(lb);
	fromstring(a, la);
	fromstring(b, lb);
	mnoz(a, b, c);

	if (c->dl) lenc = c->dl; else lenc = 1;
	dlug = max(max(lena,lenb+1),lenc);

	for (i=0; i<dlug-lena; i++) printf (" "); 
	printf ("%s\n",la); 
	for (i=0; i<dlug-lenb-1; i++) printf (" "); 
	printf ("*%s\n",lb); 

	if (lenb > 1) {

		dlug2 = lenb+1;
		dd[0] = lb[lenb-1];
		dd[1] = 0;
		fromstring(d,dd);
		mnoz (a,d,e);
		if (e->dl) lene = e->dl; else lene = 1;
		if (lene>dlug2) { dlug2 = lene; }

		for (i=0; i<dlug-dlug2; i++) printf (" "); 		
		for (i=0; i<dlug2; i++) printf ("-"); 
		printf ("\n");
	
		for (i = lenb-1; i>=0; i--) {
			dd[0] = lb[i];
			dd[1] = 0;
			fromstring(d,dd);
			mnoz (a,d,e);
			if (e->dl) lene = e->dl; else lene = 1;
			ilespacji = 0;
			for (j=0; j<dlug-lene-(lenb-i-1); j++) { 
				printf (" "); 		
				ilespacji++;
			}
			wypisz(e);
 		}

	} else {
	}

	if (lenc < dlug) { 
		for (i=0; i<ilespacji; i++) printf (" "); 
		for (i=0; i<dlug-ilespacji; i++) printf ("-"); 
		printf ("\n");
	} else {
		for (i=0; i<dlug; i++) printf ("-"); 
		printf ("\n");
	}

	for (i=0; i<dlug-lenc; i++) printf (" "); 
	wypisz (c);
}



int main()
{
	scanf("%d\n",&T);
	a = init();
	b = init();
	c = init();
	d = init();
	e = init();

	for (I=0; I<T; I++)
	{
		scanf("%s\n",str);

		if (strchr(str, '+')!=NULL) dod();
		if (strchr(str, '-')!=NULL) ode();
		if (strchr(str, '*')!=NULL) mno(); 
	
		printf ("\n");
	}

	return 0;
}

