#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SIZE 105

typedef struct {
	float t[SIZE][SIZE];
	int size;
} matrix;


int LUP_decompose (matrix *A, int *P)
{
	int i,j,k,k2;
	float tmp,p;
	int tmpi;
	int n=A->size;
	int sign=1;

	for (i=0; i<n; i++) P[i]=i;

	for (k=0; k<n; k++)
	{
		p=0;
		for (i=k; i<n; i++)
		{
			if (fabs(A->t[i][k]) >p)
			{
				p= fabs(A->t[i][k]);
				k2 = i;
			}
		}
		if (!p) return 0;

		if (k!=k2)
		{
			tmpi = P[k];
			P[k] = P[k2];
			P[k2] = tmpi;

			for (i=0; i<n; i++)
			{
				tmp = A->t[k][i];
				A->t[k][i] = A->t[k2][i];
				A->t[k2][i] = tmp;
			}
			sign = -sign;
		}

		for (i=k+1; i<n; i++)
		{
			A->t[i][k] /= A->t[k][k];
			for (j=k+1; j<n; j++)
				A->t[i][j] -= A->t[i][k] * A->t[k][j];
		}
	}

	return sign;
}

void LUP_solve (matrix *A, int *P, float *b, float *x)
{
	float y[SIZE];
	int n= A->size;
	int i,j;

	for (i=0; i<n; i++)
	{
		y[i] = b[P[i]];
		for (j=0; j<i; j++) y[i] -= A->t[i][j]*y[j];
	}

	for (i=n-1; i>=0; i--)
	{
		x[i] = y[i];
		for (j=i+1; j<n; j++)
		{
			x[i] -= A->t[i][j] * x[j];
		}
		x[i] /= A->t[i][i];
	}
}

int main()
{
	matrix A;
	int P[SIZE];
	float b[SIZE],a[SIZE];
	int TEST,test,S,C;
	int i,j;	
	int ile;
	int x;
	float sum;
	

	scanf ("%d",&TEST);
	for (test=0; test<TEST; test++) {
		scanf ("%d %d",&S,&C);
		A.size = S;
		for (i=0; i<S; i++) scanf ("%f",&b[i]);
		for (i=0; i<S; i++) {
			ile = 1;
			for (j=0; j<S; j++) {
				A.t[i][j] = ile;
				ile *= (i+1);	
			}
		}
		LUP_decompose (&A,P);
		LUP_solve(&A,P,b,a);

			for (i=0; i<S; i++) {
				printf ("%.2f ",a[i]);
			}
			printf ("\n");

		for (x = S+1; x<=S+C; x++) {
			sum = a[S-1];
			for (i=S-1; i>=0; i--) {
				sum *= (float)x;
				sum += a[i];
			}
			printf ("%.2f ",sum);
		}
		printf ("\n");
	}

	

	return 0;
}
